Skip to main content

Document Viewer Integration in React Application

  • 3 minutes to read

View Example: How to use the Document Viewer in JavaScript with React Framework

The server-side model stores a report and provides it to the HTML5 Document Viewer integrated in the client React JavaScript application.

The project consists of server and client parts.

Server (Back-End) Application

Refer to the following help topic to create a back-end application: Document Viewer Server-Side Application (ASP.NET Core)

Client (Front-End) Application

  1. Create a folder (JS in our example) to store application files. Launch the command prompt to perform the following steps to create and configure the client part.

  2. Create a new React application in the react-document-viewer folder:

    npx create-react-app react-document-viewer
    
  3. Switch to the root application folder:

    cd react-document-viewer
    
  4. Install DevExpress packages:

    npm install devextreme devexpress-reporting @devexpress/analytics-core
    
  5. Open the App.js file in the src folder (JS\react-document-viewer\src) and substitute its content with the following code snippet:

    import './App.css';
    import { useEffect, useRef } from 'react';
    import { DxReportViewer } from 'devexpress-reporting/dx-webdocumentviewer';
    import * as ko from 'knockout';
    
    const ReportViewer = () => {
      const reportUrl = ko.observable("TestReport");
      const viewerRef = useRef();
      const requestOptions = {
        host: "https://localhost:54114/",
        invokeAction: "DXXRDV"
      };
      useEffect(() => {
        const viewer = new DxReportViewer(viewerRef.current, { reportUrl, requestOptions });
        viewer.render(); 
        return () => viewer.dispose();
      })
      return (<div ref={viewerRef}></div>);
    }
    
    function App() {
      return (<div style={{ width: "100%", height: "1000px" }}>
          <ReportViewer />
      </div>);
      }
    
    export default App;
    

    This code snippet declares the ReportViewer component and returns it with the App function.

    Important

    You can modify App.js content to specify the correct server-side port (54114 in this example) and report name (TestReport in this example).

  6. Open the App.css file in the src folder (JS\react-document-viewer\src) and append the following style sheet references:

    /* ... */
    @import url("../node_modules/devextreme/dist/css/dx.light.css");
    @import url("../node_modules/@devexpress/analytics-core/dist/css/dx-analytics.common.css");
    @import url("../node_modules/@devexpress/analytics-core/dist/css/dx-analytics.light.css");
    @import url("../node_modules/devexpress-reporting/dist/css/dx-webdocumentviewer.css");
    
  7. Run the server (back-end) application.

  8. Navigate to the client application’s root folder (JS\react-document-viewer), open the command prompt, and run the client application:

    npm start
    

    The client application opens the browser at http://localhost:3000/. It displays the Document Viewer with the TestReport report.

Troubleshooting

When you start the application, you may encounter the following problems:

Page is blank

The Document Viewer page is blank. The following error message is displayed at the bottom of the page: The page is blank because the Document Viewer failed to load the report. Consult the developer for assistance. Use development mode for detailed information. If the page does not display the Document Viewer, press F12 to invoke DevTools and inspect the console messages.

Check the following:

  • The backend application is up and running.
  • The backend application runs on the port specified in the host setting of the Document Viewer component.
  • The application’s URI is compliant with the CORS policy specified in your backend application.
  • The reportName value matches an existing report. For the backend application it means that the Reports folder contains the reportName.repx file or the ReportsFactory.Reports dictionary contains the reportName entry (if the backend application originated from the DevExpress template).
  • The version of the DevExpress scripts (npm packages) should match the version of the server-side libraries (NuGet packages). You can enable Development Mode to check for library version mismatch on every request to the server. For more information, take a look at the following help topic: Server-Side Libraries Version.

Review the following help topic for more information: Troubleshooting.

Skip to main content

DevExpress v25.1 Update — Your Feedback Matters

Our What's New in v25.1 webpage includes product-specific surveys. Your response to our survey questions will help us measure product satisfaction for features released in this major update and help us refine our plans for our next major release.

Take the survey Not interested

Create a Vue Front-End Application with a Document Viewer

  • 4 minutes to read

The Web Document Viewer is used in applications that contain client and server parts:

Client
A Web Document Viewer integrated in a client Vue application displays a report provided by the server-side model.
Server
The server is an ASP.NET Core application that handles client data requests and provides access to data sources, report storage, and other back-end capabilities.

This tutorial creates and configures a client React application and a server ASP.NET Core backend. The client contains the Web Document Viewer control.

View Example

#Prerequisites

Note the following details about package versions:

  • The script version on the client should match the library version on the server.
  • DevExpress npm package versions should be identical.

#Server (Back-End) Application

#Use the DevExpress CLI Template

You can use DevExpress CLI Templates to create an ASP.NET Core back-end application. Begin with the steps below:

  1. Install DevExpress ASP.NET Core project templates from nuget.org:

    dotnet new install DevExpress.AspNetCore.ProjectTemplates
    
  2. Create a back-end Reporting application for a Document Viewer:

    console
    dotnet new dx.aspnetcore.reporting.backend -n ServerApp --add-designer false
    

    You can use the following parameters to see available command options: -? | -h | --help.

  3. Enable cross-origin requests (CORS). Specify the policy that allows any local application to access the report’s back-end. Use the SetIsOriginAllowed method to set it up.

    Call the UseCors method and pass the policy name as a parameter. The UseCors method should be called after the UseRouting method and before any MVC-related code. Place the UseCors method before the UseMvc or UseEndpoints methods.

    Open the application startup file and insert the following code:

    var builder = WebApplication.CreateBuilder(args);
    
    builder.Services.AddCors(options => {
        options.AddPolicy("AllowCorsPolicy", builder => {
            // Allow all ports on local host.
            builder.SetIsOriginAllowed(origin => new Uri(origin).Host == "localhost");
            builder.AllowAnyHeader();
            builder.AllowAnyMethod();
        });
    });
    
    var app = builder.Build();
    
    app.UseRouting();
    app.UseCors("AllowCorsPolicy");
    
    app.UseEndpoints(endpoints => {
        endpoints.MapControllerRoute(
            name: "default",
            pattern: "{controller=Home}/{action=Index}/{id?}");
    });
    
    app.Run();
    
  4. To run the server-side application, run the following command:

    console
    cd ServerApp
    dotnet run
    

#Use Visual Studio Template

To create a back-end application from a Microsoft or DevExpress Template in Visual Studio, review the following help topics:

#Client (Front-End) Application

  1. Create a Vue application with the default preset:

    console
    npm create vue@latest vue-document-viewer
    
  2. Navigate to the project folder and install DevExpress npm packages:

    console
    cd vue-document-viewer
    npm install devextreme@25.1-stable @devexpress/analytics-core@25.1-stable devexpress-reporting@25.1-stable
    
  3. Create a src/App.vue file with the following content:

    <template>
      <div ref="viewer" style="position: absolute; left: 0; right: 0; top: 0; bottom: 0"></div>
    </template>
    <script>
      import 'devexpress-reporting/dx-webdocumentviewer';
      import {DxReportViewer} from 'devexpress-reporting/dx-webdocumentviewer';
      import * as ko from 'knockout';
    
      export default {
        name: "WebDocumentViewer",
        mounted() {
          const reportUrl = ko.observable("TestReport");
          const viewerRef = this.$refs.viewer;
          const requestOptions = {
            host: " http://localhost:5000/",
            invokeAction: "DXXRDV"
          };
          const viewer = new DxReportViewer(viewerRef, {
            reportUrl,
            requestOptions
          });
          viewer.render();
        },
        beforeUnmount() {
          ko.cleanNode(this.$refs.viewer);
        }
      };
    </script>
    
  4. Add styles to the src/main.js file:

    import "devextreme/dist/css/dx.light.css";
    import "@devexpress/analytics-core/dist/css/dx-analytics.common.css";
    import "@devexpress/analytics-core/dist/css/dx-analytics.light.css";
    import "devexpress-reporting/dist/css/dx-webdocumentviewer.css";
    import { createApp } from 'vue'
    import App from './App.vue'
    
    createApp(App).mount('#app')
    
  5. Remove default project styles to avoid conflicts. To do this, remove the ./assets/main.css import in the main.js file.

#Run the Project

  1. Run the server application.

    Make sure to specify the correct server-side port (5000 in this example) and report name (TestReport in this example) in the Viewer.vue file.

  2. Run the client application:

    console
    npm run dev
    
  3. Open your browser and navigate to the URL specified in the command output to see the result.

#Troubleshooting

When you start the application, you may encounter the following issues:

#Page Is Blank

The Document Viewer page is blank. The following error message is displayed at the bottom of the page:

Could not open report ‘TestReport’

Check the following:

  • The backend application is up and running.
  • The backend application runs on the port specified in the host setting of the Document Viewer component.
  • The application’s URI is compliant with the CORS policy specified in your back-end application.
  • The reportUrl setting value matches an existing report. For the backend application, ensure that either the Reports folder contains a reportUrl.repx file or the ReportsFactory.Reports dictionary contains the reportUrl entry (if the back-end application originated from the DevExpress template).
  • The version of DevExpress npm packages should match the version of NuGet packages. Enable Development Mode to check for a library version mismatch on every request to the server. For details, review the following help topic: Server-Side Libraries Version.

Refer to the following topic for more information: Troubleshooting.